/* 
 * File:   game.h
 * Author: Arthur Brandao
 *
 * Created on 28 novembre 2018
 */

#ifndef GAME_H
#define GAME_H

/* --- Include --- */
#include "constante.h"
#include "player.h"
#include "json.h"

/* --- Struct --- */
typedef struct{
    char* name; //Nom
    int nbPlayer; //Nombre de joueur
    char* mapName; //Nom de la map
    int width; //Largeur de la map
    int height; //Hauteur de la map
    char** map; //Map
    Player player[MAXPLAYER]; //Les joueurs actuels
}Game;

/* --- Extern --- */
extern Game game[MAXGAME];
extern int nbGame;

/* --- Fonctions --- */
/**
 * Liste le nom de toutes les maps sous forme de JSON
 * @return JsonArray* Les maps existantes
 */
JsonArray* list_map();

/**
 * Liste les game en cours en JSON
 * @return JsonArray* Les games existantes
 */
JsonArray* list_game();

/**
 * Associe une map à une game
 * @param Game* La game à associé à la map
 * @param char* Le nom de la map
 */
void get_map(Game*, char*);

#endif /* GAME_H */

